declare
proc {Photo Root}
   Persons = [betty chris donald fred gary mary paul]
   Prefs= [betty#gary betty#mary chris#betty chris#gary
           fred#mary fred#donald paul#fred paul#donald]
   Alignment = {FD.record alignment Persons 1#{Length Persons}}
   NbSatisfied = {FD.int 0#{Length Prefs}}
   fun {Satisfied P#Q}
      {FD.reified.distance Alignment.P Alignment.Q '=:' 1}
      % returns S such that S <=> (|P-Q|=1)
   end 
in 
   Root = r(satisfaction: NbSatisfied
	    alignment:    Alignment)
   {FD.distinct Alignment} % no two persons at same position
   {FD.sum {Map Prefs Satisfied} '=:' NbSatisfied}
   % Creates one 0/1 variable per preference
   % Each such variable is constrained to the fact that
   % the corresponding preference is satisfied.
   % NbSatisfied is constrained to the number of satisfied
   % 0/1 variables.
   Alignment.fred <: Alignment.betty   % breaking symmetries
   {FD.distribute generic(value:max) [NbSatisfied]}
   {FD.distribute naive Alignment}
end

{Browse {SearchOne Photo}}
{ExploreOne Photo}
